/*
**	zero.c
*/
#include "x.c"

/*
#define W 480
*/
#define W 960

typedef struct {
	double x,y;
}complex;

short a[1000];

complex mul(complex a, complex b)
{
	complex z;
	z.x= a.x * b.x - a.y * b.y;
	z.y= a.y * b.x + a.x * b.y;
	return z;
}

usage()
{
	fprintf(stderr,"Usage:zero [th] IRfile\n");
	fprintf(stderr,"th:20 - 0\n");
	exit(1);
}

main(argc,argv)
char **argv;
{
	FILE *fp;
	int len,i,j,k,th=99;
	double x,y;
	complex z,sum;
	double norm;
	char name[256];
	double t;

	//unlink(*argv);
	if(argc!=3&&argc!=2)usage();
	if(argc==3) {
		th= atoi(argv[1]);
		strcpy(name,argv[2]);
	}
	else strcpy(name,argv[1]);

	norm= 0.0001;

	fp= fopen(name,"r");
	if(fp==NULL) usage();
	len= fread(a,1,2000,fp);
	len /= 2;
	fclose(fp);

	printf("len=%d\n",len);

	iwt("zero",W,W);

	for(i=0;i<360;i+=10)
	XDrawArc(dpy,w1,gc,W/12,W/12,W*10/12,W*10/12,i*64,i*64+64*2);

	XFlush(dpy);

	/*
	t= 1;
	for(i=0;i<len;i++){ t*= 0.96; a[i]*= t; }
	strcat(name,".new");
	fp= fopen(name,"w");
	fwrite(a,1,len*2,fp);
	fclose(fp);
	*/

	z.y= -1.2;
	for(j= 0; j< W; j++){
		z.x= -1.2;
	for(i= 0; i< W; i++){

		complex s={1,0};
		
		if(i==120&&j==120)continue;

		sum.x = a[0];
		sum.y = 0;

		for(k= 1;k<len;k++){
			s= mul(s,z);
			sum.x+= s.x*a[k];
			sum.y+= s.y*a[k];
		}
		if(th==99){
		if((int)(log(sum.x*sum.x + sum.y*sum.y))&1)
				 XDrawPoint(dpy,w1,gc,i,j);
		} else if(log(sum.x*sum.x + sum.y*sum.y) < th)
				XDrawPoint(dpy,w1,gc,i,j);
		/*
		printf("%5.2f %5.2f :%5.2f\n",x,y,log(sum.x*sum.x + sum.y*sum.y));
		*/
		z.x+= 2.4/W;
	}
		z.y+= 2.4/W;
		XFlush(dpy);
	}
	XFlush(dpy);
	printf("complete.\n");
	while(1);
}


