/*
**	mixer.c
*/
#include <stdio.h>
#include <stdlib.h>
#include <fcntl.h>
#include <errno.h>
#include <sys/ioctl.h>
#include <linux/soundcard.h>

char snd_dev_lbl[32][32]= SOUND_DEVICE_LABELS;
int volume, vol1, vol2;

usage(pr)char *pr;
{ fprintf(stderr,"Usage:%s vol_chan vol1 vol2\n",pr); exit(1); }

main(argc, argv) char    **argv; {
	int i, fd, flags, ret, devices, vc;
	//unlink(*argv);
	if(argc!= 4)usage(*argv);

	if ((fd= open("/dev/mixer", O_WRONLY | O_NDELAY, 0))<0)
	{ fprintf(stderr,"/dev/mixer is busy or can't be opened\n"); exit(1); }

	ret = ioctl(fd, SOUND_MIXER_READ_DEVMASK, &devices);
	if (ret == -1) devices = 0;

	vc=   atoi(argv[1]);
	vol1= atoi(argv[2]);
	vol2= atoi(argv[3]);
	volume = vol1<<8 | vol2 ;

	if(ioctl(fd, MIXER_WRITE(1<<vc), &volume)== -1)
	{ fprintf(stderr,"configuration of /dev/mixer failed\n"); exit (1); }

	close(fd);
}
